col object_owner format a30
col showconstraints format a90
col showindexes format a90
col sanity_query format a130
col metadata_ddl format a100
col get_stats format a100


with
     my_plan_table as (
                        select *
                        from plan_table
                        where plan_id = (select max(plan_id) from plan_table)
                      )
   , table_list as (
                     select object_owner,object_name
                     from my_plan_table
                     where object_type like 'TABLE%'
                     union
                     select b.table_owner,b.table_name
                     from my_plan_table a
                         ,dba_indexes b
                     where a.object_type like 'INDEX%'
                     and a.object_owner = b.owner
                     and a.object_name = b.index_name
                   )
select  object_owner
      , object_name
      , '@showconstraints '||object_owner||' '||object_name showconstraints
      , '@showindexes '||object_owner||' '||object_name showindexes
      , 'select /*+ full (a) */ count(*),'''||object_name||''' table_name from '||object_owner||'.'||object_name||' a;' sanity_query
      , 'select dbms_metadata.get_ddl(''TABLE'','''||object_name||''','''||object_owner||''') text from dual;' metadata_ddl
      , 'dbms_stats.gather_table_stats('''||object_owner||''','''||object_name||''')' get_stats
from table_list
order by 1,2
/
